> For the complete documentation index, see [llms.txt](https://docs.redivis.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.redivis.com/api/rest-api/variables/list.md).

# list

## HTTP Request

```http
GET /api/v1/tables/:tableReference/variables
GET /api/v1/workflows/:workflowReference/tables/:tableReference/variables
GET /api/v1/tables/:tableReference/uploads/:uploadReference/variables
GET /api/v1/queries/:queryId/variables
```

## Path parameters

| Parameter         |                                                                                                                                                                                                                                                                                                                                               |
| ----------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| tableReference    | A qualified reference to the table. See [referencing resources](/api/referencing-resources.md) for more information.                                                                                                                                                                                                                          |
| workflowReference | A qualified reference to a workflow. When provided, `tableReference` may be the table's name (and optional reference id) alone, and can refer to any table in the workflow, including tables from the workflow's datasources. See [referencing tables within a workflow](/api/referencing-resources.md#referencing-tables-within-a-workflow). |
| uploadReference   | A qualified reference to the upload. Follows the form `upload_name:id`                                                                                                                                                                                                                                                                        |
| queryId           | The id of a [query](/api/rest-api/queries.md)                                                                                                                                                                                                                                                                                                 |

## Query parameters

| Parameter          |                                                                                                                                                                                |
| ------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| maxResults         | Default 100. Cannot exceed 10,000                                                                                                                                              |
| pageToken          | For paginating through results, provide the value returned from the previous table.listVariables call                                                                          |
| isFileId           | Optional. If present, will only return variables that contain ids referencing [Files](/api/rest-api/files.md)                                                                  |
| includeValueLabels | **Optional, default false.** If true, each variable in the response will include its `valueLabels` (an array of `{value, label}` objects, or `null` if the variable has none). |

{% hint style="info" %}
This endpoint extends the [general API structure](/api/rest-api/general-structure.md).
{% endhint %}

## Authorization

Metadata access to the table is required. If a table's data is not public, your access token must have one of the following scopes:

* data.metadata
* data.data
* data.edit

[Learn more about authorization.](/api/rest-api/authorization.md)

## Request body

The request body must be empty.

## Response body

Returns a JSON representation of a list of [variable resources](/api/resource-definitions/variable.md).

```javascript
{
    "kind": "tableList",
    "nextPageToken": string,
    "results": [
        object(variable.list)
    ]
}
```

When `includeValueLabels` is true, each result will also contain the `valueLabels` property, as returned by [variable.get](/api/rest-api/variables/get.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.redivis.com/api/rest-api/variables/list.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
